/* Copyright David Leonard, 2000. All rights reserved. */
/* $Id: ident.c,v 1.2 2000/05/21 23:28:28 leonard Exp $ */

#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "node.h"

struct intern {
	const char *s;
	int id;
	struct intern *next;
	int is_scalar;
};

static struct intern *head = NULL;
static ident_t nextid = 0;

ident_t
new_ident(s)
	const char *s;
{
	struct intern *i;

	for (i = head; i; i = i->next)
		if (strcmp(i->s, s) == 0)
			return i->id;

	i = malloc(sizeof *i);
	i->id = nextid++;
	i->s = strdup(s);
	i->next = head;
	i->is_scalar = islower(s[0]);
	head = i;
	return i->id;	
}

const char *
ident_str(id)
	ident_t id;
{
	struct intern *i;

	for (i = head; i; i = i->next)
		if (i->id == id)
			return i->s;
	return "?";
}

int
ident_is_scalar(id)
	ident_t id;
{
	struct intern *i;

	for (i = head; i; i = i->next)
		if (i->id == id)
			return i->is_scalar;
	errx(1, "ident_is_scalar: no such ident %d", id);
}
