/* Copyright David Leonard, 2000. All rights reserved. */
/* $Id: vector.c,v 1.2 2000/05/21 23:29:48 leonard Exp $ */

#include <stdlib.h>
#include "node.h"

#define INIT_SIZE	20

vector_t
new_vector()
{
	vector_t v;

	v = malloc(sizeof *v);
	v->maxlen = INIT_SIZE;
	v->el = malloc(INIT_SIZE * sizeof v->el[0]);
	v->len = 0;
	v->refcnt = 1;
	return v;
}

void
vector_append(v, s)
	vector_t v;
	scalar_t s;
{
	if (v->len + 1 == v->maxlen) {
		v->maxlen *= 2;
		v->el = realloc(v->el, v->maxlen * sizeof v->el[0]);
	}
	v->el[v->len++] = s;
}

void
vector_free(v)
	vector_t v;
{
	if (--v->refcnt == 0) {
		free(v->el);
		v->el = NULL;
		free(v);
	}
}
